
#include "stdafx.h"
#include "GLL_Theme_Helper.h"
#include <SHLWAPI.H>
//#include <io.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#ifndef STAP_ALLOW_NONCLIENT
#define STAP_ALLOW_NONCLIENT    (1 << 0)
#define STAP_ALLOW_CONTROLS     (1 << 1)
#define STAP_ALLOW_WEBCONTENT   (1 << 2)
#endif

#ifndef DFCS_TRANSPARENT
#define DFCS_TRANSPARENT        0x0800
#define DFCS_HOT                0x1000
#define DFC_POPUPMENU           5
#endif



#ifndef CP_DROPDOWNBUTTON
#define CP_DROPDOWNBUTTON 1
#endif

#define _USE_WIN8_GROUPBOX_FIX 
#define _USE_WIN8_GROUPBOX_FIXEX
int GLL_GetWindowsVers();

#pragma comment(lib, "shlwapi.lib") //PathFileExists

/**********************************************************************/

CGLL_Theme_Helper::CGLL_Theme_Helper()
{
	dwOS = GLL_GetWindowsVers();
	Init();
	LoadDLL();
}

/**********************************************************************/

void CGLL_Theme_Helper::LoadDLL()
{
	if(m_hDll == NULL)
		m_hDll = ::LoadLibrary(_T("UxTheme.dll"));
}

/**********************************************************************/

CGLL_Theme_Helper::~CGLL_Theme_Helper()
{
	Close();
}

/**********************************************************************/

void CGLL_Theme_Helper::Init()
{
	m_hDll = NULL;
	pfnOpenThemeData = NULL;
	pfnCloseThemeData = NULL;

	pfnDrawThemeParentBackground = NULL;
	pfnDrawThemeBackground = NULL;
	pfnGetThemeColor = NULL;
	
	pfnDrawThemeText = NULL;
	pfnDrawThemeEdge = NULL;
	pfnSetWindowTheme = NULL;
	
	pfnIsAppThemed = NULL;
	pfnIsThemeActive = NULL;
}

/**********************************************************************/

void CGLL_Theme_Helper::Close()
{
	if (m_hDll)
		::FreeLibrary(m_hDll);
	Init();
}

/**********************************************************************/

HTHEME CGLL_Theme_Helper::OpenThemeData(HWND hwnd, LPCWSTR pszClassList)
{
	if(m_hDll == NULL || hwnd == NULL)
		return NULL;


	if(pfnOpenThemeData == NULL)
		pfnOpenThemeData = (PFNOPENTHEMEDATA)GetProcAddress(m_hDll,"OpenThemeData");

	if(pfnOpenThemeData)
		return (*pfnOpenThemeData)(hwnd, pszClassList);
	
	return NULL;
}

/**********************************************************************/

HRESULT CGLL_Theme_Helper::CloseThemeData(HTHEME hTheme)
{
	if(m_hDll == NULL || hTheme == NULL)
		return S_FALSE;

	if(pfnCloseThemeData == NULL)
		pfnCloseThemeData = (PFNCLOSETHEMEDATA)GetProcAddress(m_hDll,"CloseThemeData");

	if(pfnCloseThemeData)
		return (*pfnCloseThemeData)(hTheme);
	
	return S_FALSE;
}

/**********************************************************************/
COLORREF GLL_LightenColor(COLORREF col,double factor);
HRESULT CGLL_Theme_Helper::DrawThemeBackground(HTHEME hTheme, HWND hWnd, HDC hdc, int iPartId, int iStateId, const RECT* pRect, const RECT* pClipRect, bool m_bParentBkGround)
{
	if(m_hDll == NULL)
		return S_FALSE;

	/************************************************************************
	* Windows 8 GroupBox-Fix
	* Aus irgend einem Grund luft DrawThemeBackground unter Win8 nicht berall?!?!?!
	* Dies betrifft VC6 mit VC2012 geht es?!? Keine Ahnung warum und mir fehlt die Zeit!
	************************************************************************/

#ifndef BP_GROUPBOX
#define BP_GROUPBOX 4
#endif

	if(dwOS >= 62 && iPartId == BP_GROUPBOX)
		{
#ifdef _USE_WIN8_GROUPBOX_FIX

#ifndef GBS_NORMAL
#define GBS_NORMAL 1
#define EDGESHADOWCOLOR 3806
#endif

		UNUSED_ALWAYS(m_bParentBkGround);
		UNUSED_ALWAYS(pClipRect);
		UNUSED_ALWAYS(iStateId);
		UNUSED_ALWAYS(hWnd);

		CRect rc(pRect);
		COLORREF clrLine1 = GetSysColor(COLOR_3DSHADOW), clrLine2 = GetSysColor(COLOR_3DHIGHLIGHT);
		GetThemeColor(hTheme, BP_GROUPBOX, GBS_NORMAL, EDGESHADOWCOLOR, &clrLine1);

		clrLine1 = GLL_LightenColor(clrLine1, .1);

#ifdef _USE_WIN8_GROUPBOX_FIXEX		
		// Ist unter Win8 und anderer Hintergrundfarbe einfach besser zu sehen.
		Draw3dRect(hdc, rc.left, rc.top, rc.Width(), rc.Height(), clrLine1, clrLine2);
		rc.DeflateRect(1, 1);
		Draw3dRect(hdc, rc.left, rc.top, rc.Width(), rc.Height(), clrLine2, clrLine1);
#else
		// oder eben so...
		Draw3dRect(hdc, pRect->left, pRect->top, pRect->right-pRect->left, pRect->bottom-pRect->top, clrLine1,clrLine1);
#endif //_USE_WIN8_GROUPBOX_FIXEX


		return S_OK;
		}

#endif //_USE_WIN8_GROUPBOX_FIX
	/**********************************************************************/
	

	if(m_bParentBkGround)
		{
		if(pfnDrawThemeParentBackground == NULL)
			pfnDrawThemeParentBackground = (PFNDRAWTHEMEPARENTBACKGROUND) GetProcAddress(m_hDll, "DrawThemeParentBackground");

		if(pfnDrawThemeParentBackground && hWnd)
			(*pfnDrawThemeParentBackground)(hWnd, hdc, (PRECT) pRect);
		}

	if(pfnDrawThemeBackground == NULL)
		pfnDrawThemeBackground = (PFNDRAWTHEMEBACKGROUND) GetProcAddress(m_hDll, "DrawThemeBackground");

	if(pfnDrawThemeBackground && hTheme)
		{
		HRESULT hr = (*pfnDrawThemeBackground)(hTheme, hdc, iPartId, iStateId, pRect, pClipRect);
		return hr;
		}

	return S_FALSE;
}

/**********************************************************************/

HRESULT CGLL_Theme_Helper::DrawThemeText(HTHEME hTheme, HDC hdc, int iPartId, int iStateId, LPCWSTR pszText, int iCharCount, DWORD dwTextFlags, DWORD dwTextFlags2, const RECT *pRect)
{
	if(m_hDll == NULL)
		return S_FALSE;

	if(pfnDrawThemeText == NULL)
		pfnDrawThemeText = (PFNDRAWTHEMETEXT) GetProcAddress(m_hDll, "DrawThemeText");

	if(pfnDrawThemeText)
		return (*pfnDrawThemeText)(hTheme, hdc, iPartId, iStateId, pszText, iCharCount, dwTextFlags, dwTextFlags2, pRect);

	return S_FALSE;
}

/**********************************************************************/

void CGLL_Theme_Helper::FillSolidRect(HDC hdc, LPCRECT lpRect, COLORREF clr)
{
	COLORREF bkClr = ::SetBkColor(hdc, clr);
	::SetBkColor(hdc, clr);
	::ExtTextOut(hdc, 0, 0, ETO_OPAQUE, lpRect, NULL, 0, NULL);
	::SetBkColor(hdc, bkClr);
}

/**********************************************************************/

void CGLL_Theme_Helper::FillSolidRect(HDC hdc, int x, int y, int cx, int cy, COLORREF clr)
{
	COLORREF bkClr = ::SetBkColor(hdc, clr);
	CRect rect(x, y, x + cx, y + cy);
	::ExtTextOut(hdc, 0, 0, ETO_OPAQUE, &rect, NULL, 0, NULL);
	::SetBkColor(hdc, bkClr);
}

/**********************************************************************/

void CGLL_Theme_Helper::Draw3dRect(HDC hdc, LPCRECT lpRect, COLORREF clrTopLeft, COLORREF clrBottomRight)
{
	Draw3dRect(hdc, lpRect->left, lpRect->top, lpRect->right - lpRect->left,
		lpRect->bottom - lpRect->top, clrTopLeft, clrBottomRight);
}

/**********************************************************************/

void CGLL_Theme_Helper::Draw3dRect(HDC hdc, int x, int y, int cx, int cy, COLORREF clrTopLeft, COLORREF clrBottomRight)
{
	FillSolidRect(hdc, x, y, cx - 1, 1, clrTopLeft);
	FillSolidRect(hdc, x, y, 1, cy - 1, clrTopLeft);
	FillSolidRect(hdc, x + cx, y, -1, cy, clrBottomRight);
	FillSolidRect(hdc, x, y + cy, cx, -1, clrBottomRight);
}

/**********************************************************************/

HRESULT CGLL_Theme_Helper::DrawThemeEdge(HTHEME hTheme, HDC hdc, int iPartId, int iStateId, RECT *pDestRect, UINT uEdge, UINT uFlags, RECT *pContentRect)
{
	if(m_hDll == NULL)
		goto LABEL_Failed;
	

	if(pfnDrawThemeEdge == NULL)
		pfnDrawThemeEdge = (PFNDRAWTHEMEEDGE)GetProcAddress(m_hDll, "DrawThemeEdge");

	if (pfnDrawThemeEdge)
		{
		if((FAILED(pfnDrawThemeEdge(hTheme, hdc, iPartId, iStateId, pDestRect, uEdge, uFlags, pContentRect))))
			{
			goto LABEL_Failed;
			}
		}
	else
		{
LABEL_Failed:
		Draw3dRect(hdc, (LPRECT) pDestRect, GetSysColor(COLOR_3DSHADOW), GetSysColor(COLOR_3DHILIGHT));
		}
	
	return S_OK;
}

/**********************************************************************/

HRESULT CGLL_Theme_Helper::GetThemeColor(HTHEME hTheme, int iPartID, int iStateID, int iPropID, COLORREF* pColor)
{
	if(m_hDll == NULL || hTheme == NULL)
		return S_FALSE;

	if(pfnGetThemeColor == NULL)
		pfnGetThemeColor = (PFNGETTHEMECOLOR) GetProcAddress(m_hDll, "GetThemeColor");

	if(pfnGetThemeColor)
		return (SUCCEEDED(pfnGetThemeColor(hTheme, iPartID, iStateID, iPropID, pColor)));
	
	return S_OK;
}

/**********************************************************************/

HRESULT CGLL_Theme_Helper::SetWindowTheme(HWND hwnd, LPCWSTR pszSubAppName, LPCWSTR pszSubIdList)
{
	if(m_hDll == NULL)
		return S_FALSE;

	if(pfnSetWindowTheme == NULL)
		pfnSetWindowTheme = (PFNSETWINDOWTHEME)GetProcAddress(m_hDll, "SetWindowTheme");

	if (pfnSetWindowTheme)
		return (SUCCEEDED(pfnSetWindowTheme(hwnd, pszSubAppName, pszSubIdList)));
	
	return S_OK;
}

/**********************************************************************/

BOOL CGLL_Theme_Helper::IsAppThemed()
{
	if(m_hDll == NULL)
		return FALSE;

	if(pfnIsAppThemed == NULL)
		pfnIsAppThemed = (PFNISAPPTHEMED)GetProcAddress(m_hDll,"IsAppThemed");

	if(pfnIsAppThemed)
		return (*pfnIsAppThemed)();
	
	return FALSE;
}

/**********************************************************************/

BOOL CGLL_Theme_Helper::IsThemeActive()
{
	if(m_hDll == NULL)
		return FALSE;

	if(pfnIsThemeActive == NULL)
		pfnIsThemeActive = (PFNISTHEMEACTIVE)GetProcAddress(m_hDll,"IsThemeActive");
	
	if(pfnIsThemeActive)
		return (*pfnIsThemeActive)();
	
	return FALSE;
}

/**********************************************************************/

bool CGLL_Theme_Helper::IsThemeEnabled()
{
	if(IsThemeActive() == false)
		return false;

	CString m_ProgrammDirectory;
	HRSRC hrSrc = FindResource(AfxGetResourceHandle(), MAKEINTRESOURCE(1), (LPCTSTR) 24);
	GetModuleFileName(NULL, m_ProgrammDirectory.GetBuffer(MAX_PATH), MAX_PATH);
	m_ProgrammDirectory.ReleaseBuffer();
	m_ProgrammDirectory += _T(".manifest");

	//if(_taccess(m_ProgrammDirectory,0) == 0 || hrSrc)
	if(PathFileExists(m_ProgrammDirectory) || hrSrc)
		return true;

	return false;
}

/**********************************************************************/

DWORD CGLL_Theme_Helper::GetAppThemeProperties()
{
	if (m_hDll)
		{
		PFNGETTHEMEAPPPROPERTIES fnGetThemeAppProperties = (PFNGETTHEMEAPPPROPERTIES)GetProcAddress(m_hDll, "GetThemeAppProperties");
		
		if (fnGetThemeAppProperties)
			return fnGetThemeAppProperties();
		}
	
	return 0;
}

/**********************************************************************/

BOOL CGLL_Theme_Helper::SupportsTheming(int nFlag)
{
	if(IsThemeActive() == false)
		return false;

	if(m_hDll == NULL)
		return false;

	DWORD resultFlags = GetAppThemeProperties();
	bool ctrlsAreThemed = ((resultFlags & nFlag) != 0);
	return ctrlsAreThemed;
}

/**********************************************************************/

BOOL CGLL_Theme_Helper::DrawFrameControl(HTHEME hTheme, HWND hWnd, HDC hdc, LPRECT pRect, UINT nType, UINT nState, LPCRECT pClip, bool m_ParentBackGround)
{
	if (hTheme && SupportsTheming(STAP_ALLOW_CONTROLS) && SupportsTheming(STAP_ALLOW_NONCLIENT))
		{
		CString sThClass;
		int nThPart = 0, nThState = 0;

		if(GetThemeClassPartState(hWnd, nType, nState, sThClass, nThPart, nThState) == FALSE)
			return FALSE;

		DrawThemeBackground(hTheme, hWnd, hdc, nThPart, nThState, pRect, pClip, m_ParentBackGround);
		return TRUE;
		}
	
	return ::DrawFrameControl(hdc, pRect, nType, nState);
}

/**********************************************************************/

BOOL CGLL_Theme_Helper::GetThemeClassPartState(HWND hWnd, int nType, int nState, CString& sThClass, int& nThPart, int& nThState)
{
	sThClass.Empty();
	nThPart = 0;
	nThState = 0;
	
	switch(nType)
		{
		case DFC_BUTTON:
			{
			sThClass = "BUTTON";
			nThState = GLL_PBS_NORMAL;

			if(nState & DFCS_BUTTONPUSH)
				{
				nThPart = GLL_BP_PUSHBUTTON;

				if(nState & (DFCS_CHECKED | DFCS_PUSHED))
					nThState = GLL_PBS_PRESSED;

				else if(nState & DFCS_INACTIVE)
					nThState = GLL_PBS_DISABLED;

				else if(nState & DFCS_HOT)
					nThState = GLL_PBS_HOT;
				}
			else if(nState & DFCS_BUTTONRADIO)
				{
				nThPart = GLL_BP_RADIOBUTTON;

				if(nState & (DFCS_CHECKED | DFCS_PUSHED))
					{
					if(nState & DFCS_INACTIVE)
						nThState = GLL_RBS_CHECKEDDISABLED;

					else if(nState & DFCS_HOT)
						nThState = GLL_RBS_CHECKEDHOT;
					else
						nThState = GLL_RBS_CHECKEDNORMAL;
					}
				else
					{
					if(nState & DFCS_INACTIVE)
						nThState = GLL_RBS_UNCHECKEDDISABLED;

					else if(nState & DFCS_HOT)
						nThState = GLL_RBS_UNCHECKEDHOT;
					else
						nThState = GLL_RBS_UNCHECKEDNORMAL;
					}
				}
			else if((nState & DFCS_BUTTONCHECK) == DFCS_BUTTONCHECK)
				{
				nThPart = GLL_BP_CHECKBOX;

				if(nState & (DFCS_CHECKED | DFCS_PUSHED))
					{
					if(nState & DFCS_INACTIVE)
						nThState = GLL_CBS_CHECKEDDISABLED;

					else if(nState & DFCS_HOT)
						nThState = GLL_CBS_CHECKEDHOT;
					else
						nThState = GLL_CBS_CHECKEDNORMAL;
					}
				else
					{
					if(nState & DFCS_INACTIVE)
						nThState = GLL_CBS_UNCHECKEDDISABLED;

					else if(nState & DFCS_HOT)
						nThState = GLL_CBS_UNCHECKEDHOT;
					else
						nThState = GLL_CBS_UNCHECKEDNORMAL;
					}
				}
			else
				return FALSE;
			}
			break;

		case DFC_CAPTION:
			break;

		case DFC_MENU:
			break;

		case DFC_POPUPMENU:
			break;

		case DFC_SCROLL:
			{
			if(nState & DFCS_SCROLLCOMBOBOX)
				{
				sThClass = "COMBOBOX";
				nThPart = CP_DROPDOWNBUTTON;
				nThState = GLL_CBXS_NORMAL;

				if(nState & (DFCS_CHECKED | DFCS_PUSHED))
					nThState = GLL_CBXS_PRESSED;

				else if(nState & DFCS_INACTIVE)
					nThState = GLL_CBXS_DISABLED;

				else if(nState & DFCS_HOT)
					nThState = GLL_CBXS_HOT;
				}
			else if(nState & DFCS_SCROLLSIZEGRIP)
				{
				sThClass = "SCROLLBAR";
				nThPart = GLL_SBP_SIZEBOX;
				nThState = (nState & DFCS_SCROLLLEFT) ? GLL_SZB_LEFTALIGN : GLL_SZB_RIGHTALIGN;
				}
			}
			break;

		default:
			if(hWnd)
				{
				::GetClassName(hWnd, sThClass.GetBuffer(128), 128);
				sThClass.ReleaseBuffer();
				}
			break;
		}
	
	return (!sThClass.IsEmpty() && (nThPart && nThState));
}

/**********************************************************************/